#include <iostream>
#include <Windows.h>


class KFile{
private:
	HANDLE hFile;
public:
	KFile(){hFile = INVALID_HANDLE_VALUE;}

	~KFile(){
		if(hFile != INVALID_HANDLE_VALUE)
			CloseHandle(hFile);
		hFile = INVALID_HANDLE_VALUE;
	}

	HANDLE handle() const{
		return hFile;
	}

	bool isOpened(){
		return hFile != INVALID_HANDLE_VALUE;
	}

	bool open(char* path){
		hFile = CreateFile (path, GENERIC_READ, FILE_SHARE_READ|FILE_SHARE_WRITE, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
		return isOpened();
	}
};

class KMapping{
private:
	HANDLE hMapping;
public:
	KMapping(){hMapping = NULL;}
	~KMapping(){
		if(hMapping != NULL)
			CloseHandle(hMapping);
		hMapping = NULL;
	}

	HANDLE handle() const{
		return hMapping;
	}

	bool isOpened(){
		return MappingAddr != NULL;
	}

	bool open(const KFile& file){
		hMapping = CreateFileMapping (file.handle(), 0, PAGE_READONLY, 0, 0, 0);
		return isOpened();
	}
};

class KViewOfFile{
private:
	BYTE* MappingAddr;
public:
	KViewOfFile(){MappingAddr = NULL;}

	~KViewOfFile(){
		if(MappingAddr != NULL)
			UnmapViewOfFile(MappingAddr);
		MappingAddr = NULL;
	}

	BYTE* value() const{
		return MappingAddr;
	}

	bool isOpened(){
		return MappingAddr != NULL;
	}

	bool open(const KMapping& mapping){
		MappingAddr = (BYTE*)MapViewOfFile(mapping.handle(), FILE_MAP_READ, 0, 0, 0);;
		return isOpened();
	}
};

class KFileMapping{
private:
	KFile file;
	KMapping mapping;
	KViewOfFile view;

public:
	KFileMapping(){}

	~KFileMapping(){
		close();
	}

	void close(){
		view.close();
		mapping.close();
		file.close();
	}

	bool open(char* path){
		if(file.open(path) && mapping.open(file) && view.open(mapping))
			return true;
		close();
		return false;
	}

	BYTE* value() const{
		return view.value();
	}
};
