/* mystring.cpp */
/*
Copyright (C) 2010, Igor Yudincev
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. The name of the authors may not be used to endorse or promote products
   derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR `AS IS' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#include <windows.h>

//      
int Length(wchar_t *str)
{
	if (str==NULL) return 0;
	HANDLE hHeap = GetProcessHeap();
	return ((int)HeapSize(hHeap, 0, str) / sizeof(wchar_t)) - 1;
}

//   len+1 ;  len=0,   
bool SetLength(wchar_t **pStr, int len)
{
	HANDLE hHeap = GetProcessHeap();
	if (*pStr==NULL) {
		if (len>0) {
			*pStr = (wchar_t*)HeapAlloc(hHeap, 0, (len+1)*sizeof(wchar_t));
			if (*pStr==NULL) return false;
			(*pStr)[len] = 0;
		}
		return true;
	}
	//*pStr!=NULL
	if (len>0) {
		*pStr = (wchar_t*)HeapReAlloc(hHeap, 0, *pStr, (len+1)*sizeof(wchar_t));
		if (*pStr==NULL) return false;
		(*pStr)[len] = 0;
	}
	else {
		HeapFree(hHeap, 0, *pStr);
		*pStr = NULL;
	}
	return true;
}

wchar_t *Assign(wchar_t **dst, const wchar_t *src)
{
	SetLength(dst, wcslen(src));
	wcscpy(*dst, src);
	return *dst;
}

wchar_t *Assign(wchar_t **dst, const wchar_t *src, size_t nChars)
{
	size_t n = wcslen(src);
	if (n>nChars) n = nChars;
	SetLength(dst, n);
	wcsncpy(*dst, src, n);
	return *dst;
}
